/*
barcodeparser.cpp
Copyright (C)2002  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
#include <cstring>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>

#include "bhbarcode.h"

namespace bhpos{

namespace parser{

CBarcodeParser::CBarcodeParser()
{
}

CBarcodeParser::~CBarcodeParser()
{
}

int CBarcodeParser::Open(char *fname, CBarcode& bc)
{
   xmlDocPtr   doc;
   xmlNodePtr  node;
	xmlChar 	*buff;
	int			temp;
	
	doc=xmlParseFile(fname);
	if(!doc)
		return 1;

	node=xmlDocGetRootElement(doc);
	if(node==NULL){
		//fprintf(stderr,"empty document\n");
		xmlFreeDoc(doc);
		return 2;
	}
	ns=xmlSearchNsByHref(doc, node, (const xmlChar *) "http://bananapos.com/schemas/bcscanner");
	if(ns==NULL){
		// document of wrong type
		//fprintf(stderr, "document of the wrong type, BcsDef Namespace not found\n");
		xmlFreeDoc(doc);
		return 3;
   }
   if(xmlStrcmp(node->name, (const xmlChar *) "BarcodeScanner")){
   	// wrong type of file
		//fprintf(stderr,"document of the wrong type, root node != Helping");
		xmlFreeDoc(doc);
		return 4;
	}
	
	while(node && xmlIsBlankNode(node)){
		node=node->next;
	}
   if(node==0)
      return 5;

	node=node->xmlChildrenNode;
	

   while(node!=NULL){
      if((!xmlStrcmp(node->name, (const xmlChar *) "device")) && (node->ns == ns)){
			if(ParseDevice(doc, ns, node, bc)){
			   // bad device parse
		      //fprintf(stderr,"document of the wrong type, root node != Helping");
		      xmlFreeDoc(doc);
		      return 6;
		   }
	   }
	   if((!xmlStrcmp(node->name, (const xmlChar *) "bcscanner")) && (node->ns == ns)){
         if(ParseScanner(node, bc)){
         }
	   }
		node=node->next;
	}

	xmlFreeDoc(doc);

	free(filename);
	filename=strdup(fname);

	return 0;
}


int CBarcodeParser::ParseScanner(xmlNodePtr node, CBarcode& bc)
{
	xmlChar *buff;
	bool	  b;
	
	// terminator, startsentinel, endsentinel
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
	   if((!xmlStrcmp(node->name, (const xmlChar *) "terminator")) && (node->ns == ns)){
	   }
	   if((!xmlStrcmp(node->name, (const xmlChar *) "startsentinel")) && (node->ns == ns)){
	   }
	   if((!xmlStrcmp(node->name, (const xmlChar *) "endsentinel")) && (node->ns == ns)){
	   }
	   node=node->next;
	}
	
	return 0;
}


}

}
