/*
cprinterfont.cpp
Copyright (C)2005 Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#include <cstring>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>

#include "bhprinter.h"

namespace bhpos{

CPrinterFont::CPrinterFont()
{
	unit=0;
	xsize=0;
	ysize=0;
	charline=0;
}

CPrinterFont::CPrinterFont(CPrinterFont const& pf)
{
	unit=pf.unit;
	xsize=pf.xsize;
	ysize=pf.ysize;
	charline=pf.charline;
}
CPrinterFont::CPrinterFont(int u, int x, int y, int cl)
{
	unit=u;
	xsize=x;
	ysize=y;
	charline=cl;
}

CPrinterFont::~CPrinterFont()
{
}

void CPrinterFont::operator=(CPrinterFont const& pf)
{
	unit=pf.unit;
	xsize=pf.xsize;
	ysize=pf.ysize;
	charline=pf.charline;
}

bool CPrinterFont::operator==(CPrinterFont const& pf)
{
	if(unit==pf.unit && xsize==pf.xsize && ysize==pf.ysize && charline==pf.charline) return true;
	return false;
}

bool CPrinterFont::operator<(CPrinterFont const& pf)
{
	if(((unit*xsize) < (pf.unit*pf.xsize)) && ((unit*ysize) < (pf.unit*pf.ysize))) return true;
	return false;
}

void CPrinterFont::SetParameter(int param, void *v)
{
	switch(param){
	case PF_PARAM_UNIT:
		unit=*((int *) v);
		break;
	case PF_PARAM_XSIZE:
		xsize=*((int *) v);
		break;
	case PF_PARAM_YSIZE:
		ysize=*((int *) v);
		break;
	case PF_PARAM_CHARLINE:
		charline=*((int *) v);
		break;
	}
}

void CPrinterFont::GetParameter(int param, void *v)
{
	switch(param){
	case PF_PARAM_UNIT:
		*((int *) v)=unit;
		break;
	case PF_PARAM_XSIZE:
		*((int *) v)=xsize;
		break;
	case PF_PARAM_YSIZE:
		*((int *) v)=ysize;
		break;
	case PF_PARAM_CHARLINE:
		*((int *) v)=charline;
		break;
	}
}

}
